/*
 *  Amanith Python wrapper
 *  Copyright (C) 2005-2007 by Sami Kystil <sami.kyostila@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


/*
 * This macro defines a special constructor for GElement descendants.
 * The reason this is done is that we need to drop ownership of such
 * classes if they are given a containing GElement in their constructors.
 * If this isn't done, the objects would get destroyed twice -- first by
 * their containers and then by SWIG.
 */
%define DISOWN(CLASS)
%pythonappend Amanith::CLASS::CLASS "if len(args) and isinstance(args[0], GElement): self.thisown = 0"
%enddef

DISOWN(GElement)
DISOWN(GKernel)
DISOWN(GCurve1D)
DISOWN(GCurve2D)
DISOWN(GFont2D)
DISOWN(GPixelMap)
DISOWN(GAnimElement)
DISOWN(GImpExp)
